-------------------------------------------------------
-- RepWatch by Seglberg|Dragonspew (Horde) on THRALL
-- 		Whisper Me or Email Me at Seglberg@live.com
-- 
-- Thanks to Ephemerality for Helping me with the "Default Watch" Feature
-------------------------------------------------------
-- Future Additions and Improvments:
-- Need Ideas!
-------------------------------------------------------


RepWatch = LibStub("AceAddon-3.0"):NewAddon("RepWatch", "AceEvent-3.0", "AceConsole-3.0")


-------------------------------------|
--This Build's Version Information:	 |
-------------------------------------|
-- Code Version 3					 |
RepWatch.Version = "2.1.10 (Release)"
-------------------------------------|
RepWatch.Notes = "This Version Works for |cff6495EDWrath of the Lich King|r.\n\nSupport for more locations are constantly being added!\nCheck for Updates Often\n\nView the Full List of Supported Zones in the Microsoft Excel file included in the RepWatch folder.\n\nCurrently: Blizzard's Internal coding for Dalaran City is still Buggy and May Cause Problems with RepWatch"
RepWatch.VersionDesc = "\n\n\n|cffFF8C00[RepWatch] Version: " .. RepWatch.Version .. "\n\nAuthor: Seglberg of Thrall (Northrend on Beta Realms)|r"
-------------------------------------|






--Sets Variables that have Horde/Alliance Differences
if (UnitFactionGroup("player") == "Horde") then		--Player is Horde
	RepWatch.playerFaction = "Horde"
	RepWatch.dalaranFaction = "Sunreavers"
	RepWatch.classicCity1 = "Orgrimmar"
	RepWatch.classicCity2 = "Undercity"
	RepWatch.classicCity3 = "Thunder Bluff"
	RepWatch.bcCity = "Silvermoon City"

else												--Player is Alliance
	RepWatch.playerFaction = "Alliance"
	RepWatch.dalaranFaction = "Silver Covenant"
	RepWatch.classicCity1 = "Stormwind City"
	RepWatch.classicCity2 = "Darnassus"
	RepWatch.classicCity3 = "Ironforge"
	RepWatch.bcCity = "The Exodar"
	
end






--#####################--
--#   Options Table   #--
--#####################--

RepWatch.dalaranDesc = "When Enabled, the Reputation Bar will change to " .. RepWatch.dalaranFaction .. " when Entering " .. RepWatch.playerFaction .. " Parts of Dalaran City.\nDefault: On"
RepWatch.classicCityDesc1 = "When Enabled, the Reputation Bar will change to " .. RepWatch.classicCity1 .." when Entering ".. RepWatch.classicCity1 ..".\nDefault: On"
RepWatch.classicCityDesc2 = "When Enabled, the Reputation Bar will change to " .. RepWatch.classicCity2 .." when Entering ".. RepWatch.classicCity2 ..".\nDefault: On"
RepWatch.classicCityDesc3 = "When Enabled, the Reputation Bar will change to " .. RepWatch.classicCity3 .." when Entering ".. RepWatch.classicCity3 ..".\nDefault: On"
RepWatch.bcCityDesc = "When Enabled, the Reputation Bar Will Change to " .. RepWatch.bcCity .. " when Entering " .. RepWatch.bcCity .. ".\nDefault: On"

local options = {
	name = "RepWatch",
	handler = RepWatch,
	type = "group",
	childGroups = "tab",
	args = {
		generalTab = {
			name = "General",
			desc = "General Options",
			type = "group",
			order = 1,
			args = {
				generalHeader1 = {
					order = 1,
					type = "header",
					name = "General Options",
				},
				changeExalted = {
					order = 2,
					type = "toggle",
					name = "Change When Exalted",
					desc = "When Enabled, the Reputation Bar will Change even if you are Fully Exalted with that Faction.\nDefault: Off",
					get = "GetchangeExalted",
					set = "SetchangeExalted",
				},
				generalPH1 = {
					order = 3,
					type = "description",
					name = "",
				},
				showDisplay = {
					order = 4,
					type = "toggle",
					name = "Show Display",
					desc = "When Enabled, a Notice will be Displayed in the Chatbox when the Reputation Bar is Changed.\nDefault: On",
					get = "GetshowDisplay",
					set = "SetshowDisplay",
				},
				generalDesc1 = {
					order = 5,
					type = "description",
					name = "\n\n",
				},
				generalHeader2 = {
					order = 6,
					type = "header",
					name = "Default Faction",
				},
				defaultFaction = {
					order = 7,
					type = "select",
					name = "Please Choose:",
					desc = "Selects the Faction to Be\nUsed if No Faction Is Available for the Area.\nDoesn't Apply to Subzone Changes.\nDefault: None",
					values = "GetAllFactions",
					get = "GetdefaultFaction",
					set = "SetdefaultFaction",
					style = "dropdown",
				},
			},
		},
		classicTab = {
			name = "Classic",
			desc = "|cffCD853FClassic World of Warcraft|r Options",
			type = "group",
			order = 2,
			args = {
				classicHeader1 = {
					order = 1,
					type = "header",
					name = "Classic Options",
				},
				classicInstances = {
					order = 2,
					type = "toggle",
					name = "Instances",
					desc = "When Enabled, the Reputation Bar will change when Entering Classic Instances.\nExample: Molten Core\nDefault: On",
					get = "GetclassicInstances",
					set = "SetclassicInstances",
				},
				classicCities = {
					order = 3,
					type = "toggle",
					name = "Minor Cities",
					desc = "When Enabled, the Reputation Bar will change when Entering Classic Minor Cities.\nExample: Cenarion Hold\nDefault: On",
					get = "GetclassicCities",
					set = "SetclassicCities",
					},
				classicSubzones = {
					order = 4,
					type = "toggle",
					name = "Subzones",
					desc = "When Enabled, the Reputation Bar will change when Entering Classic Subzones.\nExample: Timbermaw Hold\nDefault: On",
					get = "GetclassicSubzones",
					set = "SetclassicSubzones",
				},
				classicHeader2 = {
					order = 6,
					type = "header",
					name = "Classic Cities",
				},
				classicCity1 = {
					order = 7,
					type = "toggle",
					name = RepWatch.classicCity1,
					desc = RepWatch.classicCityDesc1,
					get = "GetclassicCity1",
					set = "SetclassicCity1",
				},
				classicCity2 = {
					order = 8,
					type = "toggle",
					name = RepWatch.classicCity2,
					desc = RepWatch.classicCityDesc2,
					get = "GetclassicCity2",
					set = "SetclassicCity2",
				},
				classicCity3 = {
					order = 9,
					type = "toggle",
					name = RepWatch.classicCity3,
					desc = RepWatch.classicCityDesc3,
					get = "GetclassicCity3",
					set = "SetclassicCity3",
				},
				
			},
		},
		bcTab = {
			name = "Burning Crusade",
			desc = "|cff9ACD32The Burning Crusade|r Options",
			type = "group",
			order = 3,
			args = {
				bcHeader1 = {
					order = 1,
					type = "header",
					name = "Burning Crusade Options",
				},
				bcInstances = {
					order = 2,
					type = "toggle",
					name = "Instances",
					desc = "When Enabled, the Reputation Bar will change when Entering BC Instances.\nExample: Karazhan\nDefault: On",
					get = "GetbcInstances",
					set = "SetbcInstances",
				},
				bcCities = {
					order = 3,
					type = "toggle",
					name = "Minor Cities",
					desc = "When Enabled, the Reputation Bar will change when Entering BC Minor Cities.\nExample: Thrallmar\nDefault: On",
					get = "GetbcCities",
					set = "SetbcCities",
					},
				bcSubzones = {
					order = 4,
					type = "toggle",
					name = "Subzones",
					desc = "When Enabled, the Reputation Bar will change when Entering BC Subzones.\nExample: The Spawning Glen\nDefault: On",
					get = "GetbcSubzones",
					set = "SetbcSubzones",
				},
				bcHeader2 = {
					order = 6,
					type = "header",
					name = "Burning Crusade Cities",
				},
				bcCity = {
					order = 7,
					type = "toggle",
					name = RepWatch.bcCity,
					desc = RepWatch.bcCityDesc,
					get = "GetbcCity",
					set = "SetbcCity",
				},
				bcShatt = {
					order = 8,
					type = "toggle",
					name = "Shattrath City",
					desc = "When Enabled, the Reputation Bar will change to corresponding Shattrath factions including Sha'tar, Scryer and Aldor.\nDefault: On",
					get = "GetbcShatt",
					set = "SetbcShatt",
				},
			},
		},
		wrathTab = {
			name = "WoTLK",
			desc = "|cff1E90FFWrath of the Lich King|r Options",
			type = "group",
			order = 4,
			args = {
				wrathHeader1 = {
					order = 1,
					type = "header",
					name = "Wrath of the Lich King Options",
				},
				wrathInstances = {
					order = 2,
					type = "toggle",
					name = "Instances",
					desc = "When Enabled, the Reputation Bar will change when Entering WoTLK Instances.\nExample: Utgarde Keep\nDefault: On",
					get = "GetwrathInstances",
					set = "SetwrathInstances",
				},
				wrathCities = {
					order = 3,
					type = "toggle",
					name = "Minor Cities",
					desc = "When Enabled, the Reputation Bar will change when Entering WoTLK Minor Cities.\nExample: Vengeance Landing\nDefault: On",
					get = "GetwrathCities",
					set = "SetwrathCities",
					},
				wrathSubzones = {
					order = 4,
					type = "toggle",
					name = "Subzones",
					desc = "When Enabled, the Reputation Bar will change when Entering WoTLK Subzones.\nExample: Bleeding Vale\nDefault: On",
					get = "GetwrathSubzones",
					set = "SetwrathSubzones",
				},
				wrathHeader2 = {
					order = 5,
					type = "header",
					name = "Wrath of the Lich King Cities",
				},
				wrathDalaran = {
					order = 6,
					type = "toggle",
					name = "Dalaran City",
					desc = "When Enabled, the Reputation Bar will change to Kirin Tor when Entering Dalaran City.\nDefault: On",
					get = "GetwrathDalaran",
					set = "SetwrathDalaran",
				},
				--placeHolder = {
				--	order = 7,
				--	type = "description",
				--	name = "",
				--},
				wrathDalaranFaction = {
					order = 8,
					type = "toggle",
					tristate = true,
					name = RepWatch.dalaranFaction,
					desc = RepWatch.dalaranDesc,
					get = "GetwrathDalaranFaction",
					set = "SetwrathDalaranFaction",
				},
			},
		},
		battlegroundTab = {
			name = "Battlegrounds",
			desc = "Battleground Options",
			type = "group",
			order = 5,
			args = {
				battlegroundHeader1 = {
					order = 1,
					type = "header",
					name = "Battleground Options",
				},
				battlegroundWSG = {
					order = 2,
					type = "toggle",
					name = "Warsong Gulch",
					desc = "When Enabled, the Reputation Bar will change when Entering Warsong Gulch.\nDefault: On",
					get = "GetbattlegroundWSG",
					set = "SetbattlegroundWSG",
				},
				battlegroundAB = {
					order = 3,
					type = "toggle",
					name = "Arathi Basin",
					desc = "When Enabled, the Reputation Bar will change when Entering Arathi Basin.\nDefault: On",
					get = "GetbattlegroundAB",
					set = "SetbattlegroundAB",
				},
				battlegroundAV = {
					order = 4,
					type = "toggle",
					name = "Alterac Valley",
					desc = "When Enabled, the Reputation Bar will change when Entering Alterac Valley.\nDefault: On",
					get = "GetbattlegroundAV",
					set = "SetbattlegroundAV",
				},				
			},
		},
		creditsTab = {
			name = "Credits",
			desc = "Credits and Notes",
			type = "group",
			order = 6,
			args = {
				creditsHeader1 = {
					order = 1,
					type = "header",
					name = "Credits",
				},
				creditsDesc1 = {
					order = 2,
					type = "description",
					name = "Beta Testers:\n- Fluffykiller\n\nSpecial Thanks to Ephemerality for Helping me with the Default Watch feature.\n",
				},
				creditsHeader2 = {
					order = 3,
					type = "header",
					name = "Notes",
				},
				creditsDesc2 = {
					order = 4,
					type = "description",
					name = (RepWatch.Notes .. RepWatch.VersionDesc),
				},
			},
		},
	},
}



	
	
local defaults = {
	char = {
		changeExalted = false,
		showDisplay = true,
		defaultFaction = 1,		--1 in the List is None
		classicInstances = true,
		classicCities = true,
		classicSubzones = true,
		classicCity1 = true,
		classicCity2 = true,
		classicCity3 = true,
		bcInstances = true,
		bcCities = true,
		bcSubzones = true,
		bcCity = true,
		bcShatt = true,
		wrathInstances = true,
		wrathCities = true,
		wrathSubzones = true,
		wrathDalaran = true,
		wrathDalaranFaction = true,
		battlegroundWSG = true,
		battlegroundAB = true,
		battlegroundAV = true,
	},
}





--###################--
--# Option Handlers #--
--###################--


-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetchangeExalted(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.changeExalted)
end


--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetchangeExalted(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.changeExalted = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change even When Exalted.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change when Exalted.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetshowDisplay(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.showDisplay)
end


--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetshowDisplay(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.showDisplay = value
	if (value) then
		self:Print("Displays |cff32cd32Will|r Show In the Chatbox Window.")
	else
		self:Print("Displays |cffff0000Will Not|r Show In the Chatbox Window.")
	end
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetdefaultFaction(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.defaultFaction)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetdefaultFaction(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.defaultFaction = value
	if (self.db.char.showDisplay) then
		if (value) == 1	then	--Remember: 1 is the eqiv. to "None"
			self:Print("The Rep Bar |cffff0000Will Not|r Change if No Faction is Available for the Area")
		elseif (value) == 2 then --Remember: 2 is the quiv. to "Auto-Off"
			self:Print("The Rep Bar |cff32cd32Will Disappear|r if No Faction is Available for the Area")
		else
			self:Print("The Rep Bar Will Change to |cff32cd32", GetFactionInfo(value - 2), "|r if No Faction is Available for the Area")
		end
	end
	RepWatch:ZONE_CHANGED()
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetAllFactions()
--=--=--=--=--=--=--=--=--=--=--=--=--
	local factionList = {
		"None",
		"Auto-Off",
		}
	factionListIndex = 3
	for factionIndex = 1, GetNumFactions() do
		local isHeader = select(9, GetFactionInfo(factionIndex))
		if isHeader ~= 1 then
			factionList[factionListIndex] = GetFactionInfo(factionIndex)
		end
		factionListIndex = (factionListIndex + 1)
	end
	return (factionList)
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetclassicInstances(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.classicInstances)
end


--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetclassicInstances(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.classicInstances = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for Classic Instances.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for Classic Instances.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetclassicCities(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.classicCities)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetclassicCities(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.classicCities = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for Classic Minor Cities.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for Classic Minor Cities.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetclassicSubzones(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.classicSubzones)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetclassicSubzones(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.classicSubzones = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for Classic Subzones.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for Classic Subzones.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetclassicCity1(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.classicCity1)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetclassicCity1(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.classicCity1 = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for "..RepWatch.classicCity1..".")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for "..RepWatch.classicCity1..".")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetclassicCity2(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.classicCity2)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetclassicCity2(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.classicCity2 = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for "..RepWatch.classicCity2..".")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for "..RepWatch.classicCity2..".")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetclassicCity3(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.classicCity3)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetclassicCity3(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.classicCity3 = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for "..RepWatch.classicCity3..".")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for "..RepWatch.classicCity3..".")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetbcInstances(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.bcInstances)
end


--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetbcInstances(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.bcInstances = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for BC Instances.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for BC Instances.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetbcCities(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.bcCities)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetbcCities(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.bcCities = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for BC Minor Cities.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for BC Minor Cities.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetbcSubzones(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.bcSubzones)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetbcSubzones(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.bcSubzones = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for BC Subzones.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for BC Subzones.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetbcCity(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.bcCity)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetbcCity(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.bcCity = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for "..RepWatch.bcCity..".")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for "..RepWatch.bcCity..".")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetbcShatt(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.bcShatt)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetbcShatt(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.bcShatt = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for Shattrath Reputations.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for Shattrath Reputations.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetwrathInstances(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.wrathInstances)
end


--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetwrathInstances(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.wrathInstances = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for WotlK Instances.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for WotlK Instances.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetwrathCities(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.bcCities)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetwrathCities(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.wrathCities = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for WotlK Minor Cities.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for WotlK Minor Cities.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetwrathSubzones(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.bcSubzones)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetwrathSubzones(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.wrathSubzones = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for WotlK Subzones.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for WotlK Subzones.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetwrathDalaran(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.wrathDalaran)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetwrathDalaran(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.wrathDalaran = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change for Dalaran.")
			self.db.char.wrathDalaranFaction = true
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change for Dalaran.")
			self.db.char.wrathDalaranFaction = nil			
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetwrathDalaranFaction(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.wrathDalaranFaction)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetwrathDalaranFaction(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	if (self.db.char.wrathDalaran == true) then
		--Stops the User from being able to "Click" the Box into the nil state
		if (value == nil) then
			value = false
		end
		self.db.char.wrathDalaranFaction = value
		if (self.db.char.showDisplay) then
			if (value) then
				self:Print("The Rep Bar |cff32cd32Will|r Change for "..RepWatch.playerFaction.. " parts of Dalaran.")
			else
				self:Print("The Rep Bar |cffff0000Will Not|r Change for "..RepWatch.playerFaction.. " parts of Dalaran.")
			end
		end
		RepWatch:ZONE_CHANGED()
	end
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetbattlegroundWSG(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.battlegroundWSG)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetbattlegroundWSG(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.battlegroundWSG = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change in Warsong Gulch.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change in Warsong Gulch.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetbattlegroundAB(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.battlegroundAB)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetbattlegroundAB(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.battlegroundAB = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change in Arathi Basin.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change in Arathi Basin.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------

-----------------------------------------------
--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:GetbattlegroundAV(info)
--=--=--=--=--=--=--=--=--=--=--=--=--
	return (self.db.char.battlegroundAV)
end

--=--=--=--=--=--=--=--=--=--=--=--=--
function RepWatch:SetbattlegroundAV(info, value)
--=--=--=--=--=--=--=--=--=--=--=--=--
	self.db.char.battlegroundAV = value
	if (self.db.char.showDisplay) then
		if (value) then
			self:Print("The Rep Bar |cff32cd32Will|r Change in Alterac Valley.")
		else
			self:Print("The Rep Bar |cffff0000Will Not|r Change in Alterac Valley.")
		end
	end
	RepWatch:ZONE_CHANGED()
end
-----------------------------------------------




	
--#####################--
--# Reputation Tables #--
--#####################--

--RepTables moved to seperate file
	




--#############--
--# Functions #--
--#############--

-------------------------------------
function RepWatch:OnInitialize()
-------------------------------------
--Called When the Addon is Loaded
	
	--Register the Database
	RepWatch.db = LibStub("AceDB-3.0"):New("RepWatchDB", defaults, "Char")
	
	--Register Options Table and Menu
	LibStub("AceConfig-3.0"):RegisterOptionsTable("RepWatch", options)
	
	--Adds Menu to Blizzard's Menu
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("RepWatch", "RepWatch")
	
	--Register the /RepWatch Chat Command
	self:RegisterChatCommand("RepWatch", "ChatCommand")
	
	
end
-------------------------------------
-------------------------------------

-------------------------------------
function RepWatch:OnEnable()
-------------------------------------
--Called When the Addon is Enabled

	--Register Event Triggers
	RepWatch:RegisterEvent("ZONE_CHANGED_NEW_AREA")	--Fires everytime Channels Switch
	RepWatch:RegisterEvent("ZONE_CHANGED")			--Fires everytime Subzones Switch
	RepWatch:RegisterEvent("ZONE_CHANGED_INDOORS")	--Fires everytime subzones changes in a city
	RepWatch:RegisterEvent("PLAYER_LOGIN")			--Fires everytime the Player logs on
	
	
	--Print off Version and Enable Message
	self:Print("RepWatch Ver.|cff63B8FF", RepWatch.Version, "|rLoaded")
	self:Print("Type /RepWatch for Options Menu")
	self:Print("Please Report Bugs at: |cffCDCD00seglberg.wowinterface.com|r")

	
	--Manually Fires Change to Check when Initially Logging In
	--RepWatch:ZONE_CHANGED_NEW_AREA()

end
-------------------------------------
-------------------------------------

-------------------------------------
function RepWatch:OnDisable()
-------------------------------------
--called when the Addon is Disabled
end
-------------------------------------
-------------------------------------

-------------------------------------
function RepWatch:ChatCommand(input)
-------------------------------------
--Handles chat command input
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
	else
		--LibStub("AceConfigDialog-3.0").HandleCommand(RepWatch, "RepWatch", input)
		--RepWatch:Print("Command Not Available, type /RepWatch for Options Menu")
		InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
	end
end
-------------------------------------
-------------------------------------




-------------------------------------
function RepWatch:PLAYER_LOGIN()
-------------------------------------
	--RepWatch:ZONE_CHANGED_NEW_AREA()
end
-------------------------------------
function RepWatch:UPDATE_FACTION()
-------------------------------------
	--RepWatch:Print("Update Faction Fired")		--Debug Line
	RepWatch:ZONE_CHANGED_NEW_AREA()
	RepWatch:UnregisterEvent("UPDATE_FACTION")
end
-------------------------------------
function RepWatch:ZONE_CHANGED_INDOORS()
-------------------------------------
--RepWatch.Print("Zone Changed Indoors Fired")
	RepWatch:ZONE_CHANGED_NEW_AREA()
end
-------------------------------------
function RepWatch:ZONE_CHANGED()
-------------------------------------
	--RepWatch.Print("Zone Changed Fired")
	RepWatch:ZONE_CHANGED_NEW_AREA()
end
-------------------------------------
function RepWatch:ZONE_CHANGED_NEW_AREA()
-------------------------------------
	
	

	
	
	--Variables
	RepWatch.cCode = 0
	RepWatch.zoneFound = 0
	RepWatch.subZoneFound = 0
	RepWatch.noDisplay = 0
	
	RepWatch.currentWatched = GetWatchedFactionInfo()
	--RepWatch:Print("Current Watched:",RepWatch.currentWatched)		--Debug Line
	
	
	
	--	RepWatch.cCode Variable Legend
	-- 		-1 :: BG Map
	--		 0 :: World Map/ No Map
	--		 1 :: Kalimador
	--		 2 :: Eastern Kingdoms
	--		 3 :: Outland
	--		 4 :: Northrend
	SetMapToCurrentZone()
	RepWatch.cCode = GetCurrentMapContinent()
	
	
	if (RepWatch.cCode == -1) then
		RepWatch.zoneFound = 0
		RepWatch.noDisplay = 0
		--RepWatch.Print("RepWatch Debug","Change in a Battleground")		--Debug Line
	
		
		------|Warsong Gulch|------
		if (self.db.char.battlegroundWSG) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = BGWSG
			RepWatch.zoneFound = RepWatch:ChangeBGRep(tableName)
			self.colorCode = "|cffFF6347"
		end
		------|Arathi Basin|------
		if (self.db.char.battlegroundAB) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = BGAB
			RepWatch.zoneFound = RepWatch:ChangeBGRep(tableName)
			self.colorCode = "|cffFF6347"
		end
		------|Alterac Valley|------
		if (self.db.char.battlegroundAV) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = BGAV
			RepWatch.zoneFound = RepWatch:ChangeBGRep(tableName)
			self.colorCode = "|cffFF6347"
		end
		
		
		--Code Below is Temporary!
		----|REMOVE ONCE BLIZZARD FIXES THEIR INTERNAL CODE|----
		if (self.db.char.wrathDalaran) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = WrathDalaranCity
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			self.colorCode = "|cff63B8FF"
		end
		
		if (self.db.char.wrathDalaranFaction) and (RepWatch.subZoneFound == 0) then
			tableName = WrathDalaranReps
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			self.colorCode = "|cff63B8FF"
		end
		----|REMOVE ONCE BLIZZARD FIXES THEIR INTERNAL CODE|----
		
	
	elseif (RepWatch.cCode == 1) then
		RepWatch.zoneFound = 0
		RepWatch.noDisplay = 0
		--RepWatch.Print("RepWatch Debug","Change in Kalimador")
		-----|Classic City 1|-----
		if (self.db.char.classicCity1) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicCity1
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffF4A460"
			end
		end		
		-----|Classic City 2|-----
		if (self.db.char.classicCity2) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicCity2
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffF4A460"
			end
		end
		-----|Classic City 3|-----
		if (self.db.char.classicCity3) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicCity3
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffF4A460"
			end
		end
		-----|Burning Crusade City|------
		if (self.db.char.bcCity) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = BCCity
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end	
		-----|Classic Subzones|-----
		if (self.db.char.classicSubzones) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicSubzones
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end
		-----|Classic Minor Cities|-----
		if (self.db.char.classicCities) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicCities
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cffF4A460"
			end
		end
		-----|Classic Instances|-----
		if (self.db.char.classicInstances) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicInstances
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffF4A460"
			end
		end
		-----|Burning Crusade Subzones|-----
		if (self.db.char.bcSubzones) and (RepWatch.subZoneFound == 0) then
			tableName = BCSubzones
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|Burning Crusade Minor Cities|-----
		if (self.db.char.bcCities) and (RepWatch.subZoneFound == 0) then
			tableName = BCCities
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|Burning Crusade Instances|-----
		if (self.db.char.bcInstances) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = BCInstances
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|WotlK Instances|-----
		if (self.db.char.wrathInstances) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = WrathInstances
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end	
		
		
	
	
	elseif (RepWatch.cCode == 2) then
		RepWatch.zoneFound = 0
		RepWatch.noDisplay = 0
		--RepWatch.Print("RepWatch Debug","Change in Eastern Kingdoms")
		-----|Wrath Minor Cities|-----
		if (self.db.char.wrathCities) and (RepWatch.subZoneFound == 0) then
			tableName = WrathCities
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end	
		-----|Classic City 1|-----
		if (self.db.char.classicCity1) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicCity1
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffF4A460"
			end
		end		
		-----|Classic City 2|-----
		if (self.db.char.classicCity2) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicCity2
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffF4A460"
			end
		end
		-----|Classic City 3|-----
		if (self.db.char.classicCity3) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicCity3
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffF4A460"
			end
		end
		-----|Burning Crusade City|------
		if (self.db.char.bcCity) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = BCCity
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end	
		-----|Classic Subzones|-----
		if (self.db.char.classicSubzones) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicSubzones
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end
		-----|Classic Minor Cities|-----
		if (self.db.char.classicCities) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicCities
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end
		-----|Classic Instances|-----
		if (self.db.char.classicInstances) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = ClassicInstances
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffF4A460"
			end
		end
		-----|Burning Crusade Subzones|-----
		if (self.db.char.bcSubzones) and (RepWatch.subZoneFound == 0) then
			tableName = BCSubzones
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|Burning Crusade Minor Cities|-----
		if (self.db.char.bcCities) and (RepWatch.subZoneFound == 0) then
			tableName = BCCities
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|Burning Crusade Instances|-----
		if (self.db.char.bcInstances) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = BCInstances
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|WotlK Instances|-----
		if (self.db.char.wrathInstances) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = WrathInstances
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end	
	
	
	
	
	elseif (RepWatch.cCode == 3) then
		RepWatch.zoneFound = 0
		RepWatch.noDisplay = 0
		--RepWatch.Print("RepWatch Debug","Change in Outland")
		-----|Burning Crusade Shattrath City|-----
		if (self.db.char.bcShatt) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = BCShattrath
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|Burning Crusade Shattrath Reputations|-----
		if (self.db.char.bcShatt) and (RepWatch.subZoneFound == 0) then
			tableName = BCShattrathReps
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|Burning Crusade Subzones|-----
		if (self.db.char.bcSubzones) and (RepWatch.subZoneFound == 0) then
			tableName = BCSubzones
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|Burning Crusade Minor Cities|-----
		if (self.db.char.bcCities) and (RepWatch.subZoneFound == 0) then
			tableName = BCCities
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
		-----|Burning Crusade Instances|-----
		if (self.db.char.bcInstances) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = BCInstances
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cffADFF2F"
			end
		end
	
	else
		--RepWatch.Print("RepWatch Debug","Change in Northrend")		--Debug Line
		-----|WotlK Subzones|-----
		if (self.db.char.wrathSubzones) and (RepWatch.subZoneFound == 0) then
			tableName = WrathSubzones
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end
		-----|WotlK Minor Cities|-----
		if (self.db.char.wrathCities) and (RepWatch.subZoneFound == 0) then
			tableName = WrathCities
			RepWatch.subZoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end
		-----|WotlK Dalaran City|-----			
		if (self.db.char.wrathDalaran) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = WrathDalaranCity
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end		
		-----|WotlK Dalaran City Reputations|-----
		if (self.db.char.wrathDalaranFaction) and (RepWatch.subZoneFound == 0) then
			tableName = WrathDalaranReps
			RepWatch.subZoneFound = RepWatch:ChangeSubRep(tableName)
			if (RepWatch.subZoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end
		-----|WotlK Instances|-----
		if (self.db.char.wrathInstances) and (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then
			tableName = WrathInstances
			RepWatch.zoneFound = RepWatch:ChangeRep(tableName)
			if (RepWatch.zoneFound == 1) then
				self.colorCode = "|cff63B8FF"
			end
		end			
	end
		
		
		
		
		
		
	
	--Checks the showInChat Option for Display
	--Checks to make sure Display isnt shown for a Faction that is already being watched
	--RepWatch:Print("Value Checks:\ncurrentWatched:",RepWatch.currentWatched,"\nfactionName:",RepWatch.factionName)		--Debug Line
	if (self.db.char.showDisplay == false) or (RepWatch.currentWatched == RepWatch.factionName) then
		--RepWatch:Print("Setting noDisplay to 1")			--Debug Line
		RepWatch.noDisplay = 1
	end
	
	
	
	if (RepWatch.zoneFound == 0) and (RepWatch.subZoneFound == 0) then	
		
		
		--	Registers Update Faction Which:
		--		Since No Faction Was Found with the Area waits for a New Faction to be Discovered and then Tries to Switch to that Faction
		--		Once a Faction has been found the Event is Unregistered to stop any interference with Normal RepWatch actions. 
		--		Default Watch will still take place however if a Faction is discovered it will have higher presidence than Default Watch.
		-- 
		--	Example: Character Enters "Vengeance Landing" for the First Time however the addon cannot switch the Rep Bar because The Hand of Vengeance
		-- 		Is not a Valid Faction for that Character Yet. Once the Character talks to an NPC and discovers that Faction the Reputation Bar will then
		-- 		Change to The Hand of Vengeance.
		
		RepWatch:RegisterEvent("UPDATE_FACTION")
		--RepWatch:Print("Registered UPDATE_FACTION")		--Debug Line
		
		
		self.usedDefault = 1
		if (GetWatchedFactionInfo() == GetFactionInfo(self.db.char.defaultFaction - 2)) then
			--RepWatch:Print("Setting noDisplay to 1 (inside defaultWatch)")		--Debug Line
			RepWatch.noDisplay = 1
		end
		if (GetWatchedFactionInfo() == nil) and (self.db.char.defaultFaction == 2) then
			RepWatch.noDisplay = 1
		end
		
		
		if (self.db.char.defaultFaction == 2) then 
			SetWatchedFactionIndex(0)
			if (RepWatch.noDisplay ~= 1) then
				self:Print("Auto-Off")
			end
		elseif (self.db.char.defaultFaction ~= 1) then
			SetWatchedFactionIndex(self.db.char.defaultFaction - 2)
			if (RepWatch.noDisplay ~= 1) then
				self:Print("Changing To: [|cffFFD700" .. GetFactionInfo(self.db.char.defaultFaction - 2) .. "|r]")
			end
		end
	end
	
	
	--RepWatch:Print("Value Check on noDisplay:",RepWatch.noDisplay)		--Debug Line
	if (RepWatch.noDisplay == 0) then
		if (RepWatch.zoneFound == 1) or (RepWatch.subZoneFound == 1) then
			self:Print("Changing To: [" .. self.colorCode .. RepWatch.factionName .. "|r]")
		end
	end

	RepWatch.initialLogin = 0
	
end
-------------------------------------
-------------------------------------

-------------------------------------
function RepWatch:ChangeRep(tableName)
-------------------------------------
	
	

	
	--RepWatch:Print(tableName[GetRealZoneText()])		--Debug Line
	
	--Sets the Watched Faction using Real Zone Text
	for factionIndex = 1, GetNumFactions() do
		RepWatch.factionName = GetFactionInfo(factionIndex)	
		--RepWatch:Print(RepWatch.factionName)
		if RepWatch.factionName == tableName[GetRealZoneText()] then
			if (select(6, GetFactionInfo(factionIndex)) == 42999) then
				
				if (self.db.char.changeExalted) then
					SetWatchedFactionIndex(factionIndex)
				else
					return (0)
				end
			else
				SetWatchedFactionIndex(factionIndex)
			end
			return (1)
		end
	end
	
	
	--Sets the Watched Faction using Minimap Zone Text
	for factionIndex = 1, GetNumFactions() do
		RepWatch.factionName = GetFactionInfo(factionIndex)	
		if RepWatch.factionName == tableName[GetMinimapZoneText()] then
			if (select(6, GetFactionInfo(factionIndex)) == 42999) then
				
				if (self.db.char.changeExalted) then
					SetWatchedFactionIndex(factionIndex)
				else
					return (0)
				end
			else
				SetWatchedFactionIndex(factionIndex)
			end
			return (1)
		end
	end
	
	return (0)
end
-------------------------------------
-------------------------------------

-------------------------------------
function RepWatch:ChangeBGRep(tableName)
-------------------------------------
	--RepWatch:Print("Table Name:", tableName)
	--Sets the Watched Faction
	for factionIndex = 1, GetNumFactions() do
		RepWatch.factionName = GetFactionInfo(factionIndex)	
		if RepWatch.factionName == tableName[UnitFactionGroup("player")][GetRealZoneText()] then
			if (select(6, GetFactionInfo(factionIndex)) == 42999) then
				self.isExalted = 1
				if (self.db.char.changeExalted) then
					SetWatchedFactionIndex(factionIndex)
				else
					return (0)
				end
			else
				SetWatchedFactionIndex(factionIndex)
			end
			return (1)
		end
	end
	return (0)
end
-------------------------------------
-------------------------------------

-------------------------------------
function RepWatch:ChangeSubRep(tableName)
-------------------------------------
	
		
	--Sets the Watched Faction using Real Zone Text
	for factionIndex = 1, GetNumFactions() do
		RepWatch.subfactionName = GetFactionInfo(factionIndex)
		if RepWatch.subfactionName == tableName[GetRealZoneText()] then
	
			
			
			
			RepWatch.factionName = RepWatch.subfactionName
			if (select(6, GetFactionInfo(factionIndex)) == 42999) then
				self.isExalted = 1
				if (self.db.char.changeExalted) then
					SetWatchedFactionIndex(factionIndex)
				else
					return (0)
				end
			else
				SetWatchedFactionIndex(factionIndex)
			end
			return (1)
		end
	end
	
	--Sets the Watched Faction using Sub Zone Text
	for factionIndex = 1, GetNumFactions() do
		RepWatch.factionName2 = GetFactionInfo(factionIndex)
		if RepWatch.factionName2 == tableName[GetSubZoneText()] then
		RepWatch.noDisplay = 0
		if (GetWatchedFactionInfo() == tableName[GetSubZoneText()]) then
			RepWatch.noDisplay = 1
		end
		RepWatch.factionName = RepWatch.factionName2
			if (select(6, GetFactionInfo(factionIndex)) == 42999) then
				self.isExalted = 1
				if (self.db.char.changeExalted) then
					SetWatchedFactionIndex(factionIndex)
				else
					return (0)
				end
			else
				SetWatchedFactionIndex(factionIndex)
			end
			return (1)
		end
	end
	return (0)
end
-------------------------------------
-------------------------------------